program ModemCtl;

{$MODE OBJFPC}

uses SysUtils, StrUtils, Sockets;

type
    //Connection state
    Connection = record
        Call: boolean;
        Answer: boolean;
        Addr: longword;
        Port: word;
        Hang: boolean;
    end;

var
    ModemConn: Connection; //State of the modem
    State: file of Connection; //File storing the state of the modem
    Addr: in_addr; //Temporary variable

begin

    //Check the arguments
    if ParamStr (1) = '-c' then begin
        if ParamCount <> 2 then begin
            writeln ('Usage: modemctl [-c address:port]/[-a address:port]/-h');
            halt (1);
        end;
    end
    else if ParamStr (1) = '-a' then begin
        if ParamCount <> 2 then begin
            writeln ('Usage: modemctl [-c address:port]/[-a address:port]/-h');
            halt (1);
        end;
    end
    else begin
        if ParamCount > 1 then begin
            writeln ('Usage: modemctl [-c address:port]/[-a address:port]/-h');
            halt (1);
        end;
    end;

    //Assign the state file
    assign (State, ExpandFileName ('~/.thingamajig/connection'));

    //Set the connection
    if ParamStr (1) = '-c' then begin
        ModemConn.Call := true;
        ModemConn.Answer := false;
        try
            Addr := StrToHostAddr (ExtractDelimited (1, ParamStr (2), [':']));
            ModemConn.Addr := Addr.s_addr;
        except
            writeln ('Usage: modemctl [-c address:port]/[-a address:port]/-h');
            halt (1);
        end;
        try
            ModemConn.Port := StrToInt (ExtractDelimited (2, ParamStr (2), [':']));
        except
            writeln ('Usage: modemctl [-c address:port]/[-a address:port]/-h');
            halt (1);
        end;
        ModemConn.Hang := false;
    end
    else if ParamStr (1) = '-a' then begin
        ModemConn.Call := false;
        ModemConn.Answer := true;
        try
            Addr := StrToHostAddr (ExtractDelimited (1, ParamStr (2), [':']));
            ModemConn.Addr := Addr.s_addr;
        except
            writeln ('Usage: modemctl [-c address:port]/[-a address:port]/-h');
            halt (1);
        end;
        try
            ModemConn.Port := StrToInt (ExtractDelimited (2, ParamStr (2), [':']));
        except
            writeln ('Usage: modemctl [-c address:port]/[-a address:port]/-h');
            halt (1);
        end;
        ModemConn.Hang := false;
        ModemConn.Hang := false;
    end
    else if ParamStr (1) = '-h' then begin
        ModemConn.Call := false;
        ModemConn.Answer := false;
        ModemConn.Addr := 0;
        ModemConn.Port := 0;
        ModemConn.Hang := true;
    end        
    else begin
        writeln ('Usage: modemctl [-c address:port]/[-a address:port]/-h');
        halt (1);
    end;

    //Write the state
    try
        rewrite (State);
        write (State, ModemConn);
        close (State);
    except
        writeln ('Error: could not set the connection');
    end;

end.
